unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    CardCombo: TComboBox;
    GoButton: TButton;
    ReadTime: TTimer;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBoxOUT03: TCheckBox;
    CheckBoxOUT47: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure ReadTimeTimer(Sender: TObject);
    procedure OutCheckClick(Sender: TObject);
    procedure CheckBoxOUTSClick(Sender: TObject);
  protected
    TTLCheck: array[0..7] of TCheckBox;
    TTLData: Word;
    CardNum: LongInt;
    CardData: array of record
      CardNum: LongInt;
    end;

    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  AIOWDM;

procedure TMainForm.FormCreate(Sender: TObject);
  var
    iCardNum: LongInt;
    DeviceID: LongWord;
    Nom: AnsiString;
    NomSize: LongWord;
    I: Integer;
begin
  for iCardNum := 0 to AIOWDM.GetNumCards-1 do begin
    NomSize := 256;
    SetString(Nom, nil, NomSize);
    if AIOWDM.QueryCardInfo(iCardNum, @DeviceID, nil, @NomSize, @Nom[1]) = 0 then Continue;

    if NomSize > 0 then Dec(NomSize);
    SetLength(Nom, NomSize);

    I := Length(CardData);
    SetLength(CardData, I+1);
    CardData[I].CardNum := iCardNum;

    CardCombo.Items.Add(Nom + '[' + IntToHex(DeviceID, 4) + '] @' + IntToStr(iCardNum));
    CardCombo.ItemIndex := 0;
    GoButton.Enabled := True;
    ActiveControl := GoButton;
  end;
  TTLCheck[0] := CheckBox1;
  TTLCheck[1] := CheckBox2;
  TTLCheck[2] := CheckBox3;
  TTLCheck[3] := CheckBox4;
  TTLCheck[4] := CheckBox5;
  TTLCheck[5] := CheckBox6;
  TTLCheck[6] := CheckBox7;
  TTLCheck[7] := CheckBox8;
end;

procedure TMainForm.GoButtonClick(Sender: TObject);
var
  I: Integer;

begin
  CardNum := CardCombo.ItemIndex;
  if CardNum < 0 then Exit;

  CardCombo.Enabled := False;
  GoButton.Enabled := False;

  //Read back the TTL, to get their current state.
  TTLData := AIOWDM.RelInPortB(CardNum, $10);
  for I := 0 to 7 do TTLCheck[I].Checked := (TTLData and (1 shl I)) <> 0;

  ReadTime.Enabled := True;
  ReadTimeTimer(ReadTime);
end;

procedure TMainForm.ReadTimeTimer(Sender: TObject);
  var
    IIData: Word;
    I: Integer;
begin
  IIData := AIOWDM.RelInPortB(CardNum, $10); // Read the TTL bits.
  for I := 0 to 7 do TTLCheck[I].Checked := (IIData and (1 shl I)) <> 0;
end;

procedure TMainForm.OutCheckClick(Sender: TObject);
  var
    iBit: Integer;
begin
  iBit := (Sender as TControl).Tag;
  if TTLCheck[iBit].Checked then
    TTLData := TTLData or (1 shl iBit)
  else
    TTLData := TTLData and not (1 shl iBit)
  ;
  AIOWDM.RelOutPortB(CardNum, $10, TTLData and $FF);    // Write to the TTL bits.
end;

procedure TMainForm.CheckBoxOUTSClick(Sender: TObject);
  var
    Control: Byte;
begin
  Control := $00;
  if CheckBoxOUT03.Checked then Control := Control OR $01;
  if CheckBoxOUT47.Checked then Control := Control OR $02;
  AIOWDM.RelOutPortB(CardNum, $11, Control);
end;

end.
